<?php
/*
* $Date: 2007/02/12 $
* $Revision: 2.0 $
* $Author: exerladan $
*/
require_once( ROSTER_LIB.'item.php' );

class maxResistance {
	var $addonName = 'maxres';
	var $db;
	var $wordings;
	var $conf;
	var $armorSlots = array(
		'Head'      => 'Head',
		'Feet'      => 'Feet',
		'Chest'     => 'Chest',
		'Shoulder'  => 'Shoulder',
		'Legs'      => 'Legs',
		'Wrist'     => 'Wrist',
		'Hands'     => 'Hands',
		'Waist'     => 'Waist',
		'Main_Hand' => 'Weapon',
		'One-Hand'  => 'Weapon',
		'Two-Hand'  => '2HWeapon',
		'Off-hand'  => 'OffWeapon',
		'Off Hand'  => 'OffWeapon',
	);
	var $otherSlots = array(
		'Neck'      => 'Neck',
		'Finger'    => 'Finger',
		'Back'      => 'Back',
		'Trinket'   => 'Trinket',
		'Wand'      => 'Ranged',
		'Crossbow'  => 'Ranged',
		'Ranged'    => 'Ranged',
		'Gun'       => 'Ranged',
		'Relic'     => 'Ranged'
	);
	var $exceptions = array(
		'Plans',
		'Schematic',
		'Formula',
		'Pattern',
		'Design',
		'Juju'
	);

	function maxResistance() {
		$this->__construct();
	}
	
	function __construct() {
		global $wowdb, $wordings, $roster_conf;
		$this->db = & $wowdb;
		$this->wordings = & $wordings;
		$this->conf = & $roster_conf;
	}
	
	function checkInstalled() {
		$patched = false;
		$result_checkdb = mysql_query( 'SELECT * FROM `'.ROSTER_PLAYERSTABLE.'` LIMIT 1' );
		$i = 0;
		while ( $i < mysql_num_fields( $result_checkdb ) ) {
			$meta = mysql_fetch_field( $result_checkdb, $i );
			if ( $meta->name == 'max_res_all' ) {
				$patched = true;
				break;
			}
			$i++;
		}
		mysql_free_result( $result_checkdb );
		return $patched;
	}
	
	function install() {
		if ( ! $this->checkInstalled() ) {
			$db = $this->db;
			$result_install = $db->query( 'ALTER TABLE `'.ROSTER_PLAYERSTABLE.'` ADD `max_res_all` INT NULL, ADD `max_res_fire` INT NULL , ADD `max_res_nat` INT NULL , ADD `max_res_arc` INT NULL , ADD `max_res_fro` INT NULL , ADD `max_res_shad` INT NULL ;' );
			$db->free_result( $result_install );
			$this->refreshAllDatabaseResistances();
			return true;
		}
		return false;
	}
	
	function refreshAllDatabaseResistances() {
		$db = & $this->db;
		$query = 'SELECT member_id, name FROM '.ROSTER_PLAYERSTABLE;
		$players_result = $db->query( $query ) or die( $db->error() );
		$players = array();
		while ( $row = $db->fetch_row( $players_result ) ) {
			$result = $this->refreshMemberDatabaseResistances( $row[0] ) ;
			if ( $result ) {
				$players[] = $row;
			}
		}
		return $players;
	}

	function refreshMemberDatabaseResistances( $memberId ) {
		$w = & $this->wordings;
		$db = & $this->db;
		$client_lang_query = 'SELECT clientLocale, name FROM '.ROSTER_PLAYERSTABLE.' WHERE member_id = '. $memberId;
		$cl_result = $db->query( $client_lang_query ) or die( $db->error() );
		$row = $db->fetch_row( $cl_result );
		$l = $row[0];
		$memberName = $row[1];
		$success = false;
		if ( strlen( $l ) != 0 ) {
			$res_all	= $this->getResistances( $memberId, $l, 'all' );
			$res_fire	= $this->getResistances( $memberId, $l, 'fire' );
			$res_nat	= $this->getResistances( $memberId, $l, 'nature' );
			$res_arc	= $this->getResistances( $memberId, $l, 'arcane' );
			$res_fro	= $this->getResistances( $memberId, $l, 'frost' );
			$res_shad	= $this->getResistances( $memberId, $l, 'shadow' );		
			$max_res = 'UPDATE '.ROSTER_PLAYERSTABLE.' SET `max_res_all`=\''.$res_all['maxResistance'].'\', `max_res_fire`=\''.$res_fire['maxResistance'].'\', `max_res_nat`=\''.$res_nat['maxResistance'].'\', `max_res_arc`=\''.$res_arc['maxResistance'].'\', `max_res_fro`=\''.$res_fro['maxResistance'].'\', `max_res_shad`=\''.$res_shad['maxResistance'].'\' WHERE '.ROSTER_PLAYERSTABLE.'.member_id=\''.$memberId.'\'';
			$max_res_result = $db->query( $max_res ) or die( $db->error() );
			$success = true;
		}
		return $success;
	}
	
	function getResistances( $id, $clientLanguage, $resist ) {
		$w = & $this->wordings;
		$db = & $this->db;
		if ( in_array( $resist, array( 'fire', 'frost', 'nature', 'shadow', 'arcane' ) ) ) {
			$resistanceTranslations = array_merge( $w[$clientLanguage]['res_tooltipstring_'.$resist], $w[$clientLanguage]['res_tooltipstring_all'] );
			$racialResistanceTranslations = array_merge( $w[$clientLanguage]['res_racialstring_'.$resist], $w[$clientLanguage]['res_racialstring_all'] );
		}
		else {
			$resistanceTranslations = $w[$clientLanguage]['res_tooltipstring_all'];
			$racialResistanceTranslations = $w[$clientLanguage]['res_racialstring_all'];
		}
		$l = & $clientLanguage;
		$SoulBound = $w[$l]['tooltip_soulbound'];
		$Unique    = $w[$l]['Unique'];
		$sql = 'SELECT i.item_id, i.item_name, i.item_tooltip, i.item_color, i.member_id, i.item_texture, i.item_quantity, p.clientLocale, CASE';
		foreach ( $this->armorSlots as $name => $slot ) {
			if ( $w[$l][$name] ) {
				$sql .= ' WHEN SUBSTRING(i.item_tooltip, 1,LOCATE(\'+\', i.item_tooltip)) LIKE \'%'."\n".$w[$l][$name].'	%\' THEN \''.$slot.'\'';
			}
		}
		foreach ( $this->otherSlots as $name => $slot ) {
			if ( $w[$l][$name] ) {
				$sql .= ' WHEN SUBSTRING(i.item_tooltip, 1,LOCATE(\'+\', i.item_tooltip)) LIKE \'%'."\n".$w[$l][$name]."\n".'%\' THEN \''.$slot.'\'';
			}
		}
		$sql .= ' END AS slot';
		$sql .= ' FROM '.ROSTER_ITEMSTABLE.' AS i, '.ROSTER_PLAYERSTABLE.' AS p WHERE i.member_id = '.$id.' AND i.member_id = p.member_id AND (i.item_tooltip LIKE \'%'.$SoulBound.'%\' OR i.item_tooltip LIKE \'%'.$Unique.'%\')';
		$sqlWheres = array();
		if ( is_array( $resistanceTranslations ) && ( count( $resistanceTranslations ) > 0 ) ) {
			foreach ( $resistanceTranslations as $resistanceString ) {
				$sqlWheres[] = 'i.item_tooltip LIKE \'%'.$resistanceString.'%\'';
			}
		}
     	if ( is_array( $sqlWheres ) && ( count( $sqlWheres ) > 0 ) ) {
     		$sql .= ' AND ('.implode( ' OR ', $sqlWheres ).')';
     	}
     	foreach ( $this->exceptions as $exception ) {
     		$sql .= ' AND i.item_tooltip NOT LIKE \'%'.( isset( $w[$l][$exception] ) ? $w[$l][$exception] : $exception ).'%\'';
     	}
     	$sql .= ' ORDER BY slot ASC';
		$result = $db->query( $sql ) or die( $db->error() );
		$resistances = array();
		$equipement = array();
		while ( $row = $db->fetch_array( $result ) ) {
			$resistance = 0;
			$lines = explode( "\n", $row['item_tooltip'] );
			if ( is_array( $resistanceTranslations ) && ( count( $resistanceTranslations ) > 0 ) ) {
				foreach ( $lines as $line ) {
					if ( preg_match( '/\([0-9]+\/[0-9]+\)/', $line ) ) {
						break;
					}
					foreach ( $resistanceTranslations as $resistanceString ) {
						if ( strpos( $line, $resistanceString ) !== false ) {
							$addPosition = strpos( $line, '+' );
							$resistance += ( int ) substr( $line, $addPosition, strpos( $line, ' ' , $addPosition ) );
						}
					}
				}
			}
			$slot = $row['slot'];
			$slotNum = 0;
			if( in_array( $row['slot'], array( 'Finger', 'Trinket' ) ) ) {
				$minResistance = ( int ) min( $resistances[$slot.'0'], $resistances[$slot.'1'] );
				if ( $minResistance < $resistance ) {
					if ( $minResistance < $resistances[$slot.'0'] ) {
						$slotNum = 1;
					}
					$resistances[$slot.$slotNum] = $resistance;
					$equipement[$slot.$slotNum] = array(
						'item_id'       => $row['item_id'],
						'item_name'     => $row['item_name'],
						'item_color'    => $row['item_color'],
						'member_id'     => $row['member_id'],
						'item_texture'  => $row['item_texture'],
						'item_tooltip'  => $row['item_tooltip'],
						'item_quantity' => $row['item_quantity'],
						'clientLocale'  => $row['clientLocale'],
						'resistance'    => $resistance
					);
				}
			}
			elseif ( ( ( int ) $resistances[$slot.$slotNum] ) < $resistance ) {
				$resistances[$slot.$slotNum] = $resistance;
				$equipement[$slot.$slotNum] = array(
					'item_id'       => $row['item_id'],
					'item_name'     => $row['item_name'],
					'item_color'    => $row['item_color'],
					'member_id'     => $row['member_id'],
					'item_texture'  => $row['item_texture'],
					'item_tooltip'  => $row['item_tooltip'],
					'item_quantity' => $row['item_quantity'],
					'clientLocale'  => $row['clientLocale'],
					'resistance'    => $resistance
				);
			}
		}
		$racialResistance = 0;
		if ( is_array( $racialResistanceTranslations ) && ( count( $racialResistanceTranslations ) > 0 ) ) {
			$sqlWheres = array();
			foreach ( $racialResistanceTranslations as $resistanceString ) {
				$sqlWheres[] = 'spell_name LIKE \''.$resistanceString.'\'';
			}
			$sql = 'SELECT `spell_tooltip` FROM `roster_spellbook` WHERE `member_id` = '.$id.' AND `spell_type` LIKE \''.$w[$l]['general'].'\' AND ('.implode( ' OR ', $sqlWheres ).')';
			$result = $db->query( $sql ) or die( $db->error() );
			while ( $row = $db->fetch_array( $result ) ) {
				$racialResistance += ( int ) preg_replace( '/(\D)/', '', $row['spell_tooltip'] );
			}
			$db->free_result( $result );
		}
		if ( isset( $resistances['2HWeapon0'] ) && ( isset( $resistances['Weapon0'] ) || isset( $resistances['OffWeapon0'] ) ) ) {
			if ( $resistances['2HWeapon0'] > ( $resistances['Weapon0'] + $resistances['OffWeapon0'] ) ) {
				unset( $resistances['Weapon0'] );
				unset( $resistances['OffWeapon0'] );
				unset( $equipement['Weapon0'] );
				unset( $equipement['OffWeapon0'] );
			}
			else {
				unset( $resistances['2HWeapon0'] );
				unset( $equipement['2HWeapon0'] );
			}
		}
		$maxResistance = $racialResistance + ( ( count( $resistances ) > 0 ) ? array_sum( $resistances ) : 0 );
		$db->free_result( $result );
		return array( 'maxResistance' => $maxResistance, 'equipement' => $equipement, 'racial' => $racialResistance );
	}
	
	function getPlayerInfo( $name, $server ) {
		$db = & $this->db;
		$query = 'SELECT members.member_id, members.name, members.class, members.level, players.clientLocale, players.dateupdatedutc, '
			.'players.server, players.max_res_all, players.max_res_fire, players.max_res_nat, players.max_res_arc, players.max_res_fro, players.max_res_shad '
			.'FROM `'.ROSTER_MEMBERSTABLE.'` AS members LEFT JOIN `'.ROSTER_PLAYERSTABLE.'` AS players ON members.member_id = players.member_id WHERE members.name = \''.$name.'\' AND players.server = \''.$server.'\'';
		$result = $db->query( $query ) or die( $db->error() );
		$player = $db->fetch_array( $result );
		if ( is_array( $player ) & isset( $player['name'] ) ) {
			return $player;
		}
		else {
			return false;
		}
	}
	
	function listPlayers( $order ) {
		$db = & $this->db;
		$query = 'SELECT members.member_id, members.name, members.class, members.level, players.clientLocale, players.dateupdatedutc, '
			.'players.server, players.max_res_all, players.max_res_fire, players.max_res_nat, players.max_res_arc, players.max_res_fro, players.max_res_shad '
			.'FROM `'.ROSTER_MEMBERSTABLE.'` AS members LEFT JOIN `'.ROSTER_PLAYERSTABLE.'` AS players ON members.member_id = players.member_id';
		switch ( $order ) {
			case 'class':
				$query .= ' ORDER BY members.class ASC, members.name ASC';
				break;
			case 'level':
				$query .= ' ORDER BY members.level DESC, members.name ASC';
				break;
			case 's_res_all':
				$query .= ' ORDER BY players.max_res_all DESC, members.name ASC';
				break;
			case 's_res_fire':
				$query .= ' ORDER BY players.max_res_fire DESC, members.name ASC';
				break;
			case 's_res_nat':
				$query .= ' ORDER BY players.max_res_nat DESC, members.name ASC';
				break;
			case 's_res_arc':
				$query .= ' ORDER BY players.max_res_arc DESC, members.name ASC';
				break;
			case 's_res_fro':
				$query .= ' ORDER BY players.max_res_fro DESC, members.name ASC';
				break;
			case 's_res_shad':
				$query .= ' ORDER BY players.max_res_shad DESC, members.name ASC';
				break;
			case 'name':
			default:
			    $query .= ' ORDER BY members.name ASC';
			    break;
		}
		$result = $db->query( $query ) or die( $db->error() );
		$players = array();
		while ( $player = $db->fetch_array( $result ) ) {
			$players[] = $player;
		}
		return $players;
	}
	
	function getHTMLListPlayers( $players, $order ) {
		$w = & $this->wordings;
		$c = & $this->conf;
		$a = $this->addonName;
		$html = border('syellow','start', '')."\n"
			.'<table width="500" align="center"><tr><td><font style="font-size: xx-small; color: #CCC;">'.$w[$c['roster_lang']]['maxResTitleInfo'].'</font></td></tr></table>'."\n"
			.border('syellow','end').'<br />'."\n";
		
		// Start constructing the big table
		$tableHeaderRow = '<tr>'."\n"
			.'	<th class="membersHeader" width="12%"><a href="addon.php?roster_addon_name='.$a.'&amp;s=name">'.$w[$c['roster_lang']]['name'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=class">'.$w[$c['roster_lang']]['class'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=level">'.$w[$c['roster_lang']]['level'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_all">'.$w[$c['roster_lang']]['res_all'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_fire">'.$w[$c['roster_lang']]['res_fire'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_nat">'.$w[$c['roster_lang']]['res_nature'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_arc">'.$w[$c['roster_lang']]['res_arcane'].'</a></th>'."\n"
			.'	<th class="membersHeader"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_fro">'.$w[$c['roster_lang']]['res_frost'].'</a></th>'."\n"
			.'	<th class="membersHeaderRight"><a href="addon.php?roster_addon_name='.$a.'&amp;s=s_res_shad">'.$w[$c['roster_lang']]['res_shadow'].'</a></th>'."\n"
			.'</tr>'."\n";
		$borderBottom = '</table>'."\n".border('syellow','end');
		$counter = 0;
		foreach ( $players as $player ) {
			if ( ( $order == 'class') && ( $last_value != $player['class'] ) ) {
				if ( $counter != 0 ) {
		    		$html .= $borderBottom;
				}
				foreach ( $roster_conf['multilanguages'] as $language ) {
					$icon_name = $wordings[$language]['class_iconArray'][$player['class']];
					if( strlen($icon_name) > 0 ) {
						break;
					}
				}
				$icon_name = 'Interface/Icons/'.$icon_name;
				$icon_value = '<img class="membersRowimg" width="16" height="16" src="'.$roster_conf['interface_url'].$icon_name.'.'.$roster_conf['img_suffix'].'" alt="" />&nbsp;';
		    	$html .= '<br />'."\n".border( 'syellow', 'start', '<div class="membersGroup">'.$icon_value.$player['class'].'</div>' )."\n".'<table width="100%" cellpadding="0" cellspacing="0" align="left">'."\n".$tableHeaderRow;
			}
			elseif ( $counter == 0 ) {
				$html .= '<br />'."\n".border( 'syellow', 'start', '<div class="membersGroup">Max. Resists</div>' )."\n".'<table width="100%" cellpadding="0" cellspacing="0" align="left">'."\n".$tableHeaderRow;
	        }
			$last_value = $player['class'];
			$line = ($counter % 2) + 1;
			if( $c['index_classicon'] == 1 ) {
				foreach ( $c['multilanguages'] as $language ) {
					$icon_name = $wordings[$language]['class_iconArray'][$row['class']];
					if( strlen( $icon_name ) > 0 ) {
						break;
					}
				}
			}
			$icon_name = 'Interface/Icons/'.$icon_name;
			$classcol = '<img class="membersRowimg" width="'.$c['index_iconsize'].'" height="'.$c['index_iconsize'].'" src="'.$c['interface_url'].$icon_name.'.'.$c['img_suffix'].'" alt="" />&nbsp;';
			if ( $c['index_class_color'] == 1 ) {
				$classcol .= '<span class="class'.$player['class'].'txt">'.$player['class'].'</span>';
			}
			else {
				$classcol .= $player['class'];
			}	
			$html .= '<tr>'."\n"
				.'	<td class="membersRow'.$line.'">'.'<a href="char.php?name='.$player['name'].'&server='.$player['server'].'">'.$player['name'].'</a></td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$classcol.'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$player['level'].'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'all', $player['max_res_all'] ).'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'fire', $player['max_res_fire'] ).'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'nature', $player['max_res_nat'] ).'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'arcane', $player['max_res_arc'] ).'</td>'."\n"
				.'	<td class="membersRow'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'frost', $player['max_res_fro'] ).'</td>'."\n"
				.'	<td class="membersRowRight'.$line.'">'.$this->getHTMLResistLink( $player['name'], $player['server'], 'shadow', $player['max_res_shad'] ).'</td>'."\n"
				.'</tr>'."\n";
			$counter++;
		}
		$html .= $borderBottom;
		return $html;
	}
	
	function getHTMLPlayer( $player, $resist, $equipement, $racial, $clientLocale ) {
		$w = & $this->wordings;
		$c = & $this->conf;
		$html = '<link rel="stylesheet" type="text/css" href="'.$c['stylesheet'].'" />'."\n"
			.'<script type="text/javascript" src="'.$c['overlib'].'"></script>'."\n"
			.'<script type="text/javascript" src="'.$c['profile'].'"></script>'."\n"
			.'<table width="60%">'."\n" 
			.'	<tr>'."\n"
			.'		<td align="center">'."\n"
			.'			<font style="color: #CBA300; font-weight: bold;">'.$w[$c['roster_lang']]['MaxRes'].'</font>'."\n"
			.'		</td>'."\n"
			.'	</tr>'."\n"
			.'	<tr>'."\n"
			.'		<td align="center">'."\n"
			.'			<font style="font-size: xx-small; color: #CBA300; font-weight: bold;">'.$w[$c['roster_lang']]['maxResIndivInfo'].' <a href="'.$script_filename.'">'.$w[$c['roster_lang']]['goBack'].'</a></font>'."\n"
			.'		</td>'."\n"
			.'	</tr>'."\n"
			.'</table>'."\n"
			.'<div align="'.$c['char_bodyalign'].'">'."\n"
			.'	<br />'."\n"
			.'	<table border="0" cellpadding="0" cellspacing="0" >'."\n"
			.'		<tr>'."\n"
			.'			<td colspan="2">'."\n"
			.'				<span class="lastupdated">'.$w[$c['roster_lang']]['lastupdate'].': '.$this->formatDateCharDataUpdated( $player['dateupdatedutc'] ).'</span>'."\n"
			.'			</td>'."\n"
			.'		</tr>'."\n"
			.'		<tr>'."\n"
			.'			<td align="left">'."\n"
			.'				'.$this->getHTMLEquipement( $player, $resist, $equipement, $clientLocale )."\n"
			.'			</td>'."\n"
			.'			<td valign="top">'."\n"
			.'				'.$this->getHTMLPlayerSummary( $player, $resist, $equipement, $racial, $clientLocale )."\n"
			.'			</td>'."\n"
			.'		</tr>'."\n"
			.'	</table>'."\n"
			.border( 'syellow', 'end' );
	   	return $html;
	}
	
	function getHTMLPlayerSummary( $player, $resist, $equipement, $racial, $clientLocale ) {
		$w = & $this->wordings;
		$c = & $this->conf;
        $html = border('syellow','start',$wordings[$this->data['clientLocale']]['GearUsed'])
			.'<table width="405" cellspacing="0" cellpadding="0" border="0">'."\n"
			.'	<tr>'."\n"
			.'		<td colspan="2">'."\n"
			.'		</td>'."\n"
			.'	</tr>'."\n"
			.'	<tr class="membersHeader">'."\n"
			.'		<th colspan="1">'.$w[$clientLocale]['MaxDot'].' '.$w[$clientLocale][$resist].'</th>'."\n"
			.'		<td>'.$w[$clientLocale]['res_total'].'</td>'."\n"
			.'	</tr>'."\n";
		$row = 0;
		$maxResistance = 0;
		foreach( $equipement as $itemData ) {
			//$item = & new item( $itemData );
			$html .= '	<tr class="membersRow'.(($row%2)+1).'">'."\n"
				.'		<td>'."\n"
				.'			<span'.( strlen( $itemData['item_color'] ) ? ' style="color:#'.$itemData['item_color'].'"' : '' ).'>'.$itemData['item_name'].'</span>'."\n"
				.'		</td>'."\n"
				.'		<td>'.$itemData['resistance'].'</td>'."\n"
				.'	</tr>'."\n";
			$maxResistance += $itemData['resistance'];
		}
		if ( $racial ) {
			$html .= '	<tr class="membersRow'.(($row%2)+1).'">'."\n"
				.'		<td>'.$w[$clientLocale]['res_racial_resistance'].' :</td>'."\n"
				.'		<td>'.$racial.'</td>'."\n"
				.'	</tr>'."\n";
			$maxResistance += $racial;
		}
		$html .= '	<tr class="membersRow'.(($row%2)+1).'">'."\n"
			.'		<td>'.$w[$clientLocale]['res_total'].' :</td>'."\n"
			.'		<td>'.$maxResistance.'</td>'."\n"
			.'	</tr>'."\n"
			.'	<tr><td colspan="2"></td></tr>'."\n"
			.'</table>'."\n"
			.border('syellow','end');
		return $html;
    }
    
    function getHTMLResistLink( $name, $server, $resist, $resist_value ) {
		$html = '';
		$script_url = basename($_SERVER['PHP_SELF']);
		if ( isset( $_SERVER['QUERY_STRING'] ) ) {
			$script_url .= '?'.$_SERVER['QUERY_STRING'];
		}
		$findstr = '&name';
		$trimstr = strpos( $script_url, $findstr );
		if ( $trimstr !== false ) {
			$script_url = substr( $script_url, 0, $trimstr );
		}
		if ( $resist_value == 0 ) {
			$html = $resist_value."\n";
		}
		else {
			$html = '<a href="'.$script_url.'&amp;name='.$name.'&amp;server='.$server.'&amp;resist='.urlencode($resist).'">'.$resist_value.'</a>'."\n";
		}
		return $html;
	}
	
	function getHTMLEquipement( $player, $resist, $equipement, $clientLocale ) {
		$html = '<div class="char" id="char"> <!-- Begin char -->'."\n"
			.'	<div class="main"> <!-- Begin char-main -->'."\n"
			.'		<div class="top" id="top"> <!-- Begin char-main-top -->'."\n"
			.'			<div class="headline_1"> '.$player['RankName'].' '.$player['name'].' </div>'."\n"
			.'			<div class="headline_2">Level '.$player['level'].' | '.$player['sex'].' '.$player['race'].' '.$player['class'].'</div>'."\n"
			.( isset( $player['guild_name'] ) ? '			<div class="headline_2">'.$player['guild_title'].' of '.$player['guild_name'].'</div>'."\n" : '' )
			.'		</div> <!-- End char-main-top -->'."\n"
			.'		<div class="page1" id="page1"> <!-- begin char-main-page1 -->'."\n"
			.'			<div class="left"> <!-- begin char-main-page1-left -->'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Head0'], 'Head' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Neck0'], 'Neck' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Shoulder0'], 'Shoulder' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Back0'], 'Back' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Chest0'], 'Chest' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( null, 'Shirt').'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( null, 'Tabard').'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Wrist0'], 'Wrist' ).'</div>'."\n"
			.'			</div> <!-- end char-main-page1-left -->'."\n"
			.'			<div class="middle"> <!-- begin char-main-page1-middle -->'."\n"
			.'				<div class="portrait"> <!-- begin char-main-page1-middle-portrait -->'."\n"
			.'					<div class="resistance"> <!-- begin char-main-page1-middle-portrait-resistance -->'."\n"
			.$this->getHTMLResistance( $player, 'fire', $clientLocale )."\n"
			.$this->getHTMLResistance( $player, 'nature', $clientLocale )."\n"
			.$this->getHTMLResistance( $player, 'arcane', $clientLocale )."\n"
			.$this->getHTMLResistance( $player, 'frost', $clientLocale )."\n"
			.$this->getHTMLResistance( $player, 'shadow', $clientLocale )."\n"
			.'					</div> <!-- end char-main-page1-middle-portrait-resistance -->'."\n"
			.'					<div class="health_mana"> <!-- begin char-main-page1-middle-portrait-health_mana -->'."\n"
			.'						<div class="health"></span></div>'."\n"
			.'						<div class="mana"></span></div>'."\n"
			.'					</div> <!-- end char-main-page1-middle-portrait-health_mana -->'."\n"
			.'					<div class="talentPoints"> <!-- begin char-main-page1-middle-portrait-talentPoints -->'."\n"
			.'					</div> <!-- end char-main-page1-middle-portrait-talentPoints -->'."\n"
			.'					<div class="xp"> <!-- begin char-main-page1-middle-portrait-xp -->'."\n"
			.'						<div class="xpbox">'."\n"
			.'						</div>'."\n"
			.'					</div> <!-- end char-main-page1-middle-portrait-xp -->'."\n"
			.'				</div> <!-- end char-main-page1-middle-portrait -->'."\n"
			.'				<div class="bottom"> <!-- begin char-main-page1-middle-bottom -->'."\n"
			.'					<div class="padding">'."\n"
			.'						<ul class="stats">'."\n"
			.'							<li></li>'."\n"
			.'							<li></li>'."\n"
			.'							<li></li>'."\n"
			.'							<li></li>'."\n"
			.'							<li></li>'."\n"
			.'							<li></li>'."\n"
			.'						</ul>'."\n"
			.'						<ul class="stats">'."\n"
			.'							<li>'."\n"
			.'								<ul>'."\n"
			.'									<li></li>'."\n"
			.'									<li></li>'."\n"
			.'								</ul>'."\n"
			.'							</li>'."\n"
			.'							<li>'."\n"
			.'								<ul>'."\n"
			.'									<li></li>'."\n"
			.'									<li></li>'."\n"
			.'								</ul>'."\n"
			.'							</li>'."\n"
			.'						</ul>'."\n"
			.'					</div> <!-- end char-main-page1-middle-bottom-padding -->'."\n"
			.'					<div class="hands">'."\n"
			.( isset( $equipement['2HWeapon0'] ) ?
				'						<div class="weapon0">'.$this->getHTMLEquipementSlot( $equipement['2HWeapon0'], 'MainHand' ).'</div>'."\n"
				.'						<div class="weapon1">'.$this->getHTMLEquipementSlot( null, 'SecondaryHand' ).'</div>'."\n"
			:
				'						<div class="weapon0">'.$this->getHTMLEquipementSlot( $equipement['Weapon0'], 'MainHand' ).'</div>'."\n"
				.'						<div class="weapon1">'.$this->getHTMLEquipementSlot( $equipement['OffWeapon0'], 'SecondaryHand' ).'</div>'."\n"
			)
			.'						<div class="weapon2">'.$this->getHTMLEquipementSlot( $equipement['Ranged0'], 'Ranged' ).'</div>'."\n"
			.'						<div class="ammo">'.$this->getHTMLEquipementSlot( null, 'Ammo' ).'</div>'."\n"
			.'					</div> <!-- end char-main-page1-middle-bottom-hands -->'."\n"
			.'				</div> <!-- end char-main-page1-middle-bottom -->'."\n"
			.'			</div> <!-- end char-main-page1-middle -->'."\n"
			.'			<div class="right"> <!-- begin char-main-page1-right -->'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Hands0'], 'Hands' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Waist0'], 'Waist' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Legs0'], 'Legs' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Feet0'], 'Feet' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Finger0'], 'Finger0' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Finger1'], 'Finger1' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Trinket0'], 'Trinket0' ).'</div>'."\n"
			.'				<div class="equip">'.$this->getHTMLEquipementSlot( $equipement['Trinket1'], 'Trinket1' ).'</div>'."\n"
			.'			</div> <!-- end char-main-page1-right -->'."\n"
			.'		</div> <!-- end char-main-page1 -->'."\n"
			.'	</div> <!-- end char-main -->'."\n"
			.'	<div class="bottomBorder">'."\n"
			.'	</div>'."\n"
			.'	<div class="tabs"> <!-- begin char-tabs -->'."\n"
			.'	</div> <!-- end char-tabs -->'."\n"
			.'</div> <!-- end char -->'."\n";
		return $html;
	}

    function getHTMLEquipementSlot( $itemData, $slot ) {
		global $img_url; // Added this global variable to use in the image link
		if( is_array( $itemData ) && ( count( $itemData ) > 0 ) ) {
			$item = & new item( $itemData );
			$html = $item->out();
		}
		else {
			$html = '<div class="item">'."\n"
				.'	<span style="z-index: 1001;" onMouseover="return overlib(\''.$slot.':<br />No item equipped\');" onMouseout="return nd();">'
				.( ($slot == 'Ammo') ?
					'<img src="'.$img_url.'img/Interface/EmptyEquip/'.$slot.'.gif" class="iconsmall" /></a>'
				:
					'<img src="'.$img_url.'img/Interface/EmptyEquip/'.$slot.'.gif" class="icon" /></a>'
				)
				.'</span>'."\n"
				.'</div>';
		}
		return $html;
	}
	
    function getHTMLResistance( $player, $resist, $clientLocale ) {
		$w = & $this->wordings;
		$c = & $this->conf;
		$html = '';
        switch ( $resist ) {
			case 'fire':
				$name = $w[$clientLocale]['res_fire'];
				$sql_name = 'max_res_fire';
				$tooltip = $w[$clientLocale]['max_res_fire_tooltip'];
				$color = 'red';
				break;
			case 'nature':
				$name = $w[$clientLocale]['res_nature'];
				$sql_name = 'max_res_nat';
				$tooltip = $w[$clientLocale]['max_res_nature_tooltip'];
				$color = 'green';
				break;
			case 'arcane':
				$name = $w[$clientLocale]['res_arcane'];
				$sql_name = 'max_res_arc';
				$tooltip = $w[$clientLocale]['max_res_arcane_tooltip'];
				$color = 'yellow';
				break;
			case 'frost':
				$name = $w[$clientLocale]['res_frost'];
				$sql_name = 'max_res_fro';
				$tooltip = $w[$clientLocale]['max_res_frost_tooltip'];
				$color = 'blue';
				break;
			case 'shadow':
				$name = $w[$clientLocale]['res_shadow'];
				$sql_name = 'max_res_shad';
				$tooltip = $w[$clientLocale]['max_res_shadow_tooltip'];
				$color = 'purple';
				break;
		}
        $tooltipheader = $name;
        $line = '<span style="color: '.$color.'; font-size: 12px; font-weight: bold;">'.$tooltipheader.'</span><br />';
        $line .= '<span style="color: #DFB801; text-align: left;">'.$tooltip.'</span>';
        $line = str_replace("'", "\'", $line);
        $line = str_replace('"','&quot;', $line);
        $html = '<span style="z-index: 1002;" onMouseover="return overlib(\''.$line.'\');" onMouseout="return nd();">';
        $html .= '<span class="'.$resist.'">';
        $html .= '<span class="white">'.$this->getHTMLResistLink( $player['name'], $player['server'], $resist, $player[$sql_name] ).'</span>';
        $html .= '</span></span>'."\n";
        return $html;
    }

	function formatDateCharDataUpdated( $date ) {
		global $phptimeformat;
		$w = & $this->wordings;
		$c = & $this->conf;
		$day = substr($date,3,2);
		$month = substr($date,0,2);
		$year = substr($date,6,2);
		$hour = substr($date,9,2);
		$minute = substr($date,12,2);
		$second = substr($date,15,2);
		$localtime = mktime($hour+$c['localtimeoffset'] ,$minute, $second, $month, $day, $year, -1);
		return date( $phptimeformat[$c['roster_lang']], $localtime);
	}
}
?>